#include "MPC5777M.h"

    /* MPC5777M slave code */
   
volatile uint32_t RecDataMaster = 0u;

static void GPIO_init()
{
    /*Slave GPIO Configuration, DSPI0_Slave*/
    //DSPI0_SS_0 PE[5]
    SIUL2.MSCR_IO[69].R = 0x308C0003UL;
    SIUL2.MSCR_MUX[882u - 512u].B.SSS = 0x3u;

    //DSPI0_SCK PJ[15]
    SIUL2.MSCR_IO[159].R = 0x308C0000UL;
    SIUL2.MSCR_MUX[881u - 512u].B.SSS = 0x3u;

    //DSPI1_SIN PK[13] 
    SIUL2.MSCR_IO[173].R = 0x308C0000UL;
    SIUL2.MSCR_MUX[880u - 512u].B.SSS = 0x6u;

    //DSPI1_SOUT PD[5] 
    SIUL2.MSCR_IO[53].R = 0x32840003UL;
}

static void DSPI0_Init(void)
{
   DSPI_0.MCR.R = 0x00000001UL;
   DSPI_0.MODE.CTAR[0].R = 0x78021004; //1mbps
   DSPI_0.RSER.B.RFDF_RE = 1;
   DSPI_0.MCR.B.HALT = 0x0u;
}

int main()
{
    GPIO_init();
   DSPI0_Init(); //slave

   // Setting up vector interrupt table and priority for DSPI_0.RFDF
   // RFDF => Receive FIFO Drain Flag.
   
    DSPI_0.PUSHR.PUSHR.R = 0x00000025; //slave ack
   
   while(DSP_0.SR.RFDF != 1);

   RecDataMaster = DSPI_0.POPR.R;
   DSPI_0.SR.R = 0xFCFE0000UL; // Clear ALL status flags.
}



